// $Id: bag_count.h,v 1.3 2017/04/25 21:12:23 leavens Exp leavens $
#ifndef BAG_COUNT
#define BAG_COUNT 1
#include <stdlib.h>
#include <string.h>
typedef struct bag_s {
    int size;
    char **elems; // an array of strings, but C doesn't like char *elems[] here
} bag_t;
typedef bag_t *bag;
// requires: sought is allocated (and not NULL) and is a null-terminated string,
//           also b is allocated (and not NULL) and is such that b->elems has
//           at least b->size elements, each of which is allocated (and not NULL)
//           and is a null-terminated string.
// ensures: result is the number of times that a string equal to sought occurs
//          as an element of b.
extern int bag_count(char *sought, bag b);
#endif
