// $Id: test_complex.c,v 1.2 2017/04/25 20:57:02 leavens Exp $
#include "tap.h"
#include "complex.h"
int main() {
    complex one = make_complex(1.0, 0.0);
    ok(one != NULL);
    ok(complex_real_part(one) == 1.0 && complex_imaginary_part(one) == 0.0);
    ok(equal_complex(one, one));
    complex i = make_complex(0.0, 1.0);
    ok(i != NULL);
    ok(complex_real_part(i) == 0.0 && complex_imaginary_part(i) == 1.0);
    ok(equal_complex(i, i));
    ok(!equal_complex(one, i));
    complex oneplusi = add_complex(one, i);
    complex iplusone = add_complex(i, one);
    ok(complex_real_part(one) == 1.0, "one's real part is unchanged");
    ok(complex_imaginary_part(one) == 0.0, "one's imag part is unchanged");
    ok(complex_real_part(i) == 0.0, "i's real part is unchanged");
    ok(complex_imaginary_part(i) == 1.0, "i's imaginary part is unchanged");
    ok(equal_complex(oneplusi, iplusone), "addition is commutative");
    ok(complex_real_part(oneplusi) == 1.0 && complex_imaginary_part(iplusone) == 1.0);
    complex twoi = add_complex(oneplusi, iplusone);
    ok(complex_real_part(twoi) == 2.0 && complex_imaginary_part(twoi) == 2.0);
    return exit_status();
}
