// $Id: testing_io.h,v 1.3 2017/02/25 19:05:49 leavens Exp $
// Author: Gary T. Leavens
// Helpers for testing interactive I/O programs

#ifndef TESTING_IO_H
#define TESTING_IO_H 1

/* Run the program in the file named progn (which must be in the PATH)
 * with input from file '${prefix}.in'
 * and output going to file '${prefix}.txt'.
 * The result is the return code from running progn. */
extern
int testprog(char *progn, char *prefix);

/* Run the 0-argument procedure proc with input from file named infn
 * (which acts as stdin) and output going to the file named outfn
 * (which captures stdout). */
extern
int runprog(char *progn, char *infn, char *outfn);

/* Run the 0-argument procedure proc with input from file '${prefix}.in'
 *  and output going to file '${prefix}.txt'. */
extern
int testproc(int (*proc)(), char *prefix);

/* Run the 0-argument procedure proc with input from file named infn
 * (which acts as stdin) and output going to the file named outfn
 * (which captures stdout). */
extern
int runproc(int (*proc)(), char *infn, char *outfn);
#endif
